﻿function GuildWho_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
end

function GuildWho_SlashHandler(msg)
	if not msg or msg == "" then
		GuildWho_Print("Type '/online' followed by the character you want to look up.");
	else
		local mainChar, altChar, lookup;
		local asAlt = "";
		local offline = true;
		local showOffline = GetGuildRosterShowOffline();
		
		-- show offline members to be able to parse them
		SetGuildRosterShowOffline(true);
		
		for i = 1, GetNumGuildMembers(true) do
			local name, _, _, _, _, _, _, note, online = GetGuildRosterInfo(i);
			
			if string.lower(msg) == string.lower(name) then
				lookup = name;
				
				-- search string matches an online character, so finish here
				if online then
					altChar = name;
					offline = false;
					break;
				end
				
				-- if this character has EPGP values as officer note, it's the main, otherwise the name in the note is
				if string.find(note, "|") then
					mainChar = name;
				else
					mainChar = note;
				end
				
				break;
			end
		end
		
		-- no character match found
		if not lookup then
			GuildWho_Print("No character named "..string.upper(string.sub(msg, 1, 1))..string.lower(string.sub(msg, 2)).." found in guild.")
			return;
		end
		
		for i = 1, GetNumGuildMembers(true) do
			local name, _, _, _, _, _, _, note, online = GetGuildRosterInfo(i);
			if (note == mainChar or name == mainChar) and online then
				altChar = name;
				asAlt = " as "..name;
				offline = false;
				break;
			end
		end
		
		-- print result
		if offline then
			GuildWho_Print(lookup.." is offline.");
		else
			GuildWho_Print(lookup.." is online"..asAlt..".");
			SendWho("n-\""..altChar.."\"");
		end
		
		-- restore old "show offline members" state
		SetGuildRosterShowOffline(showOffline);
	end
end

SlashCmdList["GWHO"] = GuildWho_SlashHandler
SLASH_GWHO1 = "/online";